﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;

namespace RadEventToCommandExamples
{
    public class ExampleViewModel
    {
        public ObservableCollection<ExampleDataItem> GridItems { get; set; }
        public ObservableCollection<string> ListItems { get; set; }

        public DelegateCommand TestCommand { get; set; }
        public DelegateCommand TestCommand2 { get; set; }

        public ExampleViewModel()
        {
            SetupData();

            TestCommand = new DelegateCommand(RunEdit);
            TestCommand2 = new DelegateCommand(RunEdit2);
        }

        public void SetupData()
        {
            Random rnd = new Random();

            GridItems = new ObservableCollection<ExampleDataItem>();
            ListItems = new ObservableCollection<string>();

            for (int i = 0; i < 100; i++)
            {
                ExampleDataItem edi = new ExampleDataItem();
                edi.ID = i;
                edi.Name = "Name " + i.ToString();
                edi.Date = DateTime.Today.AddDays(i);
                edi.IsAvailable = (i % 3 == 0 ? true : false);

                GridItems.Add(edi);
            }
        }

        // Standard version used by Blend example
        public void RunEdit(object obj)
        {
            ListItems.Add("Row Edited!");
        }

        // MVVM Light Version with PassEventArgs
        public void RunEdit2(object obj)
        {
            GridViewRowEditEndedEventArgs e = obj as GridViewRowEditEndedEventArgs;

            if (e.EditAction == GridViewEditAction.Commit)
            {
                ExampleDataItem edi = e.EditedItem as ExampleDataItem;

                ListItems.Add(string.Format("Item {0} edited with name {1}, date {2}, and availability {3}", edi.ID.ToString(), edi.Name, edi.Date.ToShortDateString(), edi.IsAvailable.ToString()));
            }
        }
    }
}
