﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.GridView;

namespace RadEventToCommandExamples
{
    public partial class GridWithEvents : UserControl
    {
        public ExampleViewModel VM;

        public GridWithEvents()
        {
            InitializeComponent();

            this.Loaded += new RoutedEventHandler(GridWithEvents_Loaded);
        }

        void GridWithEvents_Loaded(object sender, RoutedEventArgs e)
        {
            VM = new ExampleViewModel();

            xRadGridView.ItemsSource = VM.GridItems;
            xDetailListBox.ItemsSource = VM.ListItems;
        }

        private void xRadGridView_RowEditEnded(object sender, Telerik.Windows.Controls.GridViewRowEditEndedEventArgs e)
        {
            if (e.EditAction == GridViewEditAction.Commit)
            {
                ExampleDataItem edi = e.EditedItem as ExampleDataItem;

                VM.ListItems.Add(string.Format("Item {0} edited with name {1}, date {2}, and availability {3}", edi.ID.ToString(), edi.Name, edi.Date.ToShortDateString(), edi.IsAvailable.ToString()));
            }
        }
    }
}